<template>
  <div class="app-container">
    <div class="filter-container">
      <div class="filter-container-lt">
        <el-form :inline="true" label-position="left" :model="listQuery">
          <el-form-item>
            <el-input clearable v-model="listQuery.sku" placeholder="搜索SKU"
            ></el-input>
          </el-form-item>
          <el-form-item>
            <el-input clearable v-model="listQuery.videoTitle" placeholder="视频标题"
            ></el-input>
          </el-form-item>
          <el-button type="primary" @click="handleFilter">搜索</el-button>
        </el-form>
      </div>
      <!-- <div class="filter-container-rt">
        <excel-import :upload-url="'/api/upload-excel'" :headers="{ token: 'your-token' }"
          :upload-data="{ type: 'import' }" @on-success="handleImportSuccess">
          <template slot="upload-text">
            导入话题
          </template>
</excel-import>
</div> -->
    </div>

    <div class="table-container">
      <el-table   style="width: 100%" v-loading="listLoading" :key="tableKey" :data="list" row-key="id"
        stripe border fit highlight-current-row>
        <el-table-column label="序号" type="index" width="60" align="center" />
        <el-table-column label="视频ID" min-width="100" align="center" prop="id" />
        <el-table-column label="视频标题" min-width="150" align="center" prop="videoTitle" />
        <el-table-column label="原图片/视频" min-width="130" align="center" prop="videoUrl">
          <template slot-scope="scope" v-if="scope.row.rawVideoUrl">
            <div v-if="isVideoFormat(scope.row.rawVideoUrl)" class="video"
              @click="handlePlay(scope.row.rawVideoUrl)">
              <video :src="scope.row.rawVideoUrl" class="video-img" />
              <i class="el-icon-video-play" />
            </div>
            <div class="video" v-else>
              <el-image  class="video-last-img video" :src="scope.row.rawVideoUrl"
                :preview-src-list="[scope.row.rawVideoUrl]" :lazy="true"/>
              <i class="el-icon-zoom-in" />
            </div>
          </template>
        </el-table-column>
        <el-table-column label="处理后图片/视频" min-width="130" align="center" prop="videoUrl">
          <template slot-scope="scope">
            <div v-if="isVideoFormat(scope.row.videoUrl)" class="video"
              @click="handlePlay(scope.row.videoUrl)">
              <!-- <img :src="scope.row.videoCoverImageUrl" class="video-img" /> -->
              <video :src="scope.row.videoUrl" class="video-img" />
              <i class="el-icon-video-play" />
            </div>
            <div class="video" v-else>
              <el-image  class="video-last-img video" :src="scope.row.videoUrl"
                :preview-src-list="[scope.row.videoUrl]" :lazy="true"/>
              <i class="el-icon-zoom-in" />
            </div>
          </template>
        </el-table-column>
        <el-table-column label="换脸所用模特" min-width="130" align="center" prop="swapModelUrl">
          <template slot-scope="scope">
            <div class="video">
              <el-image  class="video-last-img video" :src="scope.row.swapModelUrl"
                :preview-src-list="[scope.row.swapModelUrl]" :lazy="true"/>
              <i class="el-icon-zoom-in" />
            </div>
          </template>
        </el-table-column>
        <!-- <el-table-column label="操作人" min-width="100" align="center" prop="creator" /> -->
        <el-table-column label="创建时间" min-width="100" align="center" prop="createTime" />
        <el-table-column label="下载次数" min-width="100" align="center">
          <template slot-scope="scope">
            {{ scope.row.downloadCount ? scope.row.downloadCount : '-' }}
          </template>
        </el-table-column>
        <!-- <el-table-column label="优化建议" min-width="100" align="center" prop="remark">
          <template slot-scope="scope">
            <p v-if="roles.includes('superAdmin')">
              <span class="desc">{{remark}}</span>
              <a class="look-more" href="javascript:void(0);" @click="handleViewSuggestions(scope.row)">更多&nbsp;>></a>
            </p>
            <p v-else>
              <a class="edit" href="javascript:void(0);" @click="handleEditSuggestions(scope.row)"><i
                  class="el-icon-edit" /></a>
            </p>
          </template>
        </el-table-column> -->
        <!-- <el-table-column v-permission="['superAdmin']" label="使用账号" width="100" align="center" prop="createTime">
          <template slot-scope="scope">
            <el-popover placement="top-start" width="200" trigger="hover" :content="scope.row.videoDesc">
              <span class="desc" slot="reference"></span>
            </el-popover>
          </template>
        </el-table-column>
        <el-table-column label="生成账号" min-width="100" align="center" prop="createTime" /> -->
        <el-table-column label="操作" align="center" width="160" v-bind="device !== 'mobile' ? { fixed: 'right' } : {}">
          <template slot-scope="scope">
            <el-tooltip class="item" effect="dark" content="下载" placement="top">
              <el-button type="primary" :loading="scope.row && scope.row.id
                  ? downloadingRows[scope.row.id]
                  : false
                " size="mini" icon="el-icon-download" circle @click="handleDownload(scope.row)" />
            </el-tooltip>
            <el-tooltip class="item" effect="dark" content="播放" placement="top">
              <el-button type="success" size="mini" icon="el-icon-caret-right" circle
                @click="handlePlay(scope.row.videoUrl)" />
            </el-tooltip>
            <el-tooltip class="more" effect="dark" content="删除" placement="top">
              <el-button type="danger" size="mini" icon="el-icon-delete-solid" circle
                @click="handleDelete(scope.row)" />
            </el-tooltip>
            <el-tooltip class="more" style="margin: 10px 0 0 0;" effect="dark" content="更多操作" placement="top">
              <el-dropdown trigger="click" @command="command => handleAdvise(command, scope.row)">
                <el-button size="mini" type="info" icon="el-icon-more" circle title="更多操作" />
                <el-dropdown-menu class="dropdown-menu" slot="dropdown">
                  <el-dropdown-item command="addAdvise">优化建议</el-dropdown-item>
                  <el-dropdown-item command="editAdvise">查看建议</el-dropdown-item>
                </el-dropdown-menu>
              </el-dropdown>
            </el-tooltip>
            <!-- <el-tooltip class="more" effect="dark" content="更多" placement="top">
              <el-dropdown trigger="click" @command="command => handleMore(command, scope.row)">
                <el-button size="mini" type="primary" icon="el-icon-more" circle title="更多" />
                <el-dropdown-menu class="dropdown-menu" slot="dropdown">
                  <el-dropdown-item command="changeTopic">修改话题</el-dropdown-item>
                  <el-dropdown-item command="delete">删除</el-dropdown-item>
                </el-dropdown-menu>
              </el-dropdown>
            </el-tooltip> -->
          </template>
        </el-table-column>
      </el-table>
    </div>

    <!-- 分页 -->
    <swPage v-if="total > 0" key="2" :listQuery="listQuery" :total="total" pos="btmRight" @retPage="retPage" />
    <!-- 视频播放 -->
    <video-player ref="videoPlayer" :video-url="currentVideoUrl" :video-title="currentVideoTitle"
      @close="handlePlayerClose" />
    <!-- 优化建议 -->
    <suggestion-table ref="suggestionTable" />
    <!-- 编辑优化建议 -->
    <edit-suggestion ref="editSuggestion" />
    <el-image ref="elImage" style="width: 0; height: 0;" :src="imageUrl" :preview-src-list="[imageUrl]">
    </el-image>
  </div>
</template>

<script>
import waves from "@/directive/waves";
import swPage from "@/views/common/swPage";
import { auditStatus } from "@/constants/index";
import { getValueByKey } from "@/utils/index";
// import ExcelImport from "@/components/ExcelImport";
import EditSuggestion from "@/components/Suggestion/editSuggestion";
import SuggestionTable from "@/components/Suggestion/suggestionTable";

import { fetchOralVideoList, deleteOralVideoList, addSuggestion } from "@/api/video";
import downloadUtil from "@/utils/downloadUtil";
import VideoPlayer from "@/components/VideoPlayer";
import { mapGetters } from "vuex";

export default {
  name: "faceswapVideoIndex",
  directives: {
    waves
  },
  components: {
    swPage,
    VideoPlayer,
    SuggestionTable,
    EditSuggestion
    // ExcelImport,
    // changeTopic
  },
  computed: {
    ...mapGetters(["device", "roles"]) // 从 vuex 中获取设备类型
  },
  data() {
    return {
      auditStatus,
      tableKey: 0,
      list: [],
      total: 0,
      listLoading: false,
      downloadingRows: {},
      listQuery: {
        currentPage: 1,
        pageSize: 10,
        videoTitle: null,
        type: 3,
        sku: null
      },
      currentVideoUrl: null,
      currentVideoTitle: null,
      currentVideo: {},
      imageUrl: null
    };
  },
  //页面创建的时候执行
  created() {
    this.getList();
  },
  methods: {
    getValueByKey,
    isVideoFormat(url) {
      if (!url) return false;
      const extension = url
        .toLowerCase()
        .split(".")
        .pop();
      return["mp4", "mov",].includes(extension);
    },
    // 新增图片格式检测方法
    isImageFormat(url) {
      if (!url) return false;
      const extension = url
        .toLowerCase()
        .split(".")
        .pop();
      return ["jpg", "jpeg", "png", "gif", "webp"].includes(extension);
    },
    getList() {
      this.listLoading = true;
      const params = {}
      for (const key in this.listQuery) {
        const value = this.listQuery[key]
        if (value !== null && value !== '' && value !== undefined) {
          params[key] = value
        }
      }
      fetchOralVideoList(params).then(res => {
        if (200 == res.code) {
          this.total = res.data.total;
          this.list = res.data.rows;
        }
        this.listLoading = false;
      });
    },
    retPage() {
      //分页
      this.getList();
    },
    handleFilter() {
      this.listQuery.page = 1;
      this.getList();
    },
    // 视频下载
    async handleDownload(row) {
      const { videoUrl, videoTitle, id, sku } = row;
      this.$set(this.downloadingRows, id, true);
      try {
        const title = sku ? videoTitle + "_" + sku : videoTitle;
        const res = await downloadUtil.fileDownload(videoUrl, title);
        if (res) {
          const params = {
            "videoId": id,
            "operationType": 2
          }
          addSuggestion(params).then(res =>{
            if(res.code == 200){}
          })
          this.$message.success("下载成功");
        }
      } catch (error) {
        this.$message.error(error.message);
      } finally {
        this.$set(this.downloadingRows, id, false);
      }
    },
    handlePlay(url) {
      if (!url) {
        this.$message.error("媒体地址不存在");
        return;
      }

      if (this.isVideoFormat(url)) {
        // 视频播放逻辑
        this.currentVideoUrl = url;
        this.currentVideoTitle =  url.split("/").pop();
        this.$refs.videoPlayer.show();
      } else if (this.isImageFormat(url)) {
        // 新增图片格式判断
        this.$nextTick(() => {
          this.imageUrl = url;
          this.$refs.elImage.clickHandler();
        });
      } else {
        this.$message.error("不支持的文件格式");
      }
    },

    handlePlayerClose() {
      this.currentVideoUrl = "";
      this.currentVideoTitle = "";
    },
    handleDelete(row) {
      //删除
      this.$confirm("是否删除该图片/视频?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        const { id } = row;
        deleteOralVideoList([id]).then(() => {
          this.$notify({
            title: "成功",
            message: "删除成功",
            type: "success",
            duration: 3000
          });
          const index = this.list.indexOf(row);
          this.list.splice(index, 1);
        });
      });
    },
    //更多
    handleMore(command, row) {
      if (command === "delete") {
        this.handleDelete(row); // 删除
      } else if (command === "changeTopic") {
        this.changeTopic(row); // 修改话题
      }
    },
    handleAdvise(command, row) {
      if (command == 'addAdvise') {
        this.handleEditSuggestions(row)
      }
      if (command == 'editAdvise') {
        this.handleViewSuggestions(row)
      }
    },
    handleViewSuggestions(row) {
      this.$refs.suggestionTable.show(row);
    },
    handleEditSuggestions(row) {
      this.$refs.editSuggestion.show(row);
    },
    handleCofirmSuggestion() {
      this.retPage();
    }
  }
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import "@/styles/layout.scss";

.button {
  .el-button {
    margin-bottom: 10px;

    &:last-child {
      margin-bottom: 0;
    }
  }
}

.video-last-img {
  display: flex;
  align-items: center;
  justify-content: center;
  margin-top: 5px;

  /deep/.el-image__preview {
    width: 80px;
    height: 80px;
    border: 1px solid #eee;
    object-fit: cover;
    object-position: top;
    cursor: pointer;
  }
}

.video {
  position: relative;
  display: flex;
  align-content: center;
  justify-content: center;

  &:hover {
    i {
      opacity: 1;
      pointer-events: none;
    }

    .video-img {
      opacity: 0.6;
    }
  }

  &-img {
    width: 80px;
    height: 80px;
    border: 1px solid #eee;
    vertical-align: top;
    object-fit: cover;
    object-position: top;
    cursor: pointer;
  }

  i {
    width: 80px;
    height: 80px;
    position: absolute;
    top: 85%;
    left: 50%;
    transform: translate(-50%, -50%);
    font-size: 20px;
    font-weight: bold;
    color: #fff;
    opacity: 0;
    cursor: pointer;
  }
}

.status-tag {
  display: inline-block;
  width: 8px;
  height: 8px;
  border-radius: 50%;
  margin-right: 6px;
}

.status-pending {
  background-color: #e6a23c;
}

.status-success {
  background-color: #67c23a;
}

.status-error {
  background-color: #f56c6c;
}

.filter-btn {
  height: 40px;
}

.desc {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  line-height: 1.5;
  max-height: 3em;
}

.more {
  margin-left: 10px;
}

.look-more {
  font-size: 12px;
  color: #ae8877;
  text-decoration: underline;
}

.edit {
  font-size: 16px;
  color: #ae8877;
}
</style>
